Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalEvaluator.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalEvaluator.cs	(revision 17295)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/IntervalEvaluator.cs	(revision 17295)
@@ -0,0 +1,64 @@
+﻿using System;
+using System.Collections.Generic;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  public sealed class IntervalEvaluator : Interpreter<AlgebraicInterval> {
+    [ThreadStatic]
+    private IDictionary<string, Interval> intervals;
+
+    public Interval Evaluate(ISymbolicExpressionTree tree, IDictionary<string, Interval> intervals) {
+      this.intervals = intervals;
+      var code = Compile(tree);
+      Evaluate(code);
+      if (code[0].value.LowerBound.Value.Value > code[0].value.UpperBound.Value.Value) throw new InvalidProgramException($"lower: {code[0].value.LowerBound.Value.Value} > upper: {code[0].value.UpperBound.Value.Value}");
+      return new Interval(code[0].value.LowerBound.Value.Value, code[0].value.UpperBound.Value.Value);
+    }
+
+    public Interval Evaluate(ISymbolicExpressionTree tree, IDictionary<string, Interval> intervals, ISymbolicExpressionTreeNode[] paramNodes, out double[] lowerGradient, out double[] upperGradient) {
+      this.intervals = intervals;
+      var code = Compile(tree);
+      Evaluate(code);
+      lowerGradient = new double[paramNodes.Length];
+      upperGradient = new double[paramNodes.Length];
+      var l = code[0].value.LowerBound;
+      var u = code[0].value.UpperBound;
+      for (int i = 0; i < paramNodes.Length; ++i) {
+        if (paramNodes[i] == null) continue;
+        if (l.Gradient.Elements.TryGetValue(paramNodes[i], out AlgebraicDouble value)) lowerGradient[i] = value;
+        if (u.Gradient.Elements.TryGetValue(paramNodes[i], out value)) upperGradient[i] = value;
+      }
+      return new Interval(code[0].value.LowerBound.Value.Value, code[0].value.UpperBound.Value.Value);
+    }
+
+    protected override void InitializeInternalInstruction(ref Instruction instruction, ISymbolicExpressionTreeNode node) {
+      instruction.value = new AlgebraicInterval(0, 0);
+    }
+
+
+    protected override void InitializeTerminalInstruction(ref Instruction instruction, ConstantTreeNode constant) {
+      instruction.dblVal = constant.Value;
+      instruction.value = new AlgebraicInterval(
+        new MultivariateDual<AlgebraicDouble>(instruction.dblVal, constant, 1.0),
+        new MultivariateDual<AlgebraicDouble>(instruction.dblVal, constant, 1.0) // use node as key
+        );
+    }
+
+    protected override void InitializeTerminalInstruction(ref Instruction instruction, VariableTreeNode variable) {
+      instruction.dblVal = variable.Weight;
+      var v1 = instruction.dblVal * intervals[variable.VariableName].LowerBound;
+      var v2 = instruction.dblVal * intervals[variable.VariableName].UpperBound;
+      var lower = Math.Min(v1, v2);
+      var upper = Math.Max(v1, v2);
+      // we assume that the for variable nodes ( v(x,w) = w * x ) the gradient is returned for parameter w
+      instruction.value = new AlgebraicInterval(
+        low: new MultivariateDual<AlgebraicDouble>(v: lower, key: variable, dv: intervals[variable.VariableName].LowerBound),
+        high: new MultivariateDual<AlgebraicDouble>(v: upper, key: variable, dv: intervals[variable.VariableName].UpperBound)
+        );
+    }
+
+    protected override void LoadVariable(Instruction a) {
+      // nothing to do
+    }
+  }
+}
Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/MultivariateDual.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/MultivariateDual.cs	(revision 17295)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/MultivariateDual.cs	(revision 17295)
@@ -0,0 +1,93 @@
+﻿using System.Diagnostics;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  /// <summary>
+  /// An algebraic type which has a value as well as the partial derivatives of the value over multiple variables.
+  /// </summary>
+  /// <typeparam name="V"></typeparam>
+  [DebuggerDisplay("v={Value}; dv={dv}")]
+  public class MultivariateDual<V> : IAlgebraicType<MultivariateDual<V>> where V : IAlgebraicType<V>, new() {
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    private V v;
+    public V Value => v;
+
+    [DebuggerBrowsable(DebuggerBrowsableState.Never)]
+    private AlgebraicSparseVector<object, V> dv;
+    public AlgebraicSparseVector<object, V> Gradient => dv; // <key,value> partial derivative identified via the key
+
+    private MultivariateDual(MultivariateDual<V> orig) { this.v = orig.v.Clone(); this.dv = orig.dv.Clone(); }
+
+    /// <summary>
+    /// Constructor without partial derivative
+    /// </summary>
+    /// <param name="v"></param>
+    public MultivariateDual(V v) { this.v = v.Clone(); this.dv = new AlgebraicSparseVector<object, V>(); }
+
+    /// <summary>
+    /// Constructor for multiple partial derivatives
+    /// </summary>
+    /// <param name="v"></param>
+    /// <param name="keys"></param>
+    /// <param name="dv"></param>
+    public MultivariateDual(V v, object[] keys, V[] dv) { this.v = v.Clone(); this.dv = new AlgebraicSparseVector<object, V>(keys, dv); }
+
+    /// <summary>
+    /// Constructor for a single partial derivative 
+    /// </summary>
+    /// <param name="v"></param>
+    /// <param name="key"></param>
+    /// <param name="dv"></param>
+    public MultivariateDual(V v, object key, V dv) { this.v = v.Clone(); this.dv = new AlgebraicSparseVector<object, V>(new[] { key }, new[] { dv }); }
+
+    /// <summary>
+    /// Constructor with a given value and gradient. For internal use.
+    /// </summary>
+    /// <param name="v">The value (not cloned).</param>
+    /// <param name="gradient">The gradient (not cloned).</param>
+    internal MultivariateDual(V v, AlgebraicSparseVector<object, V> gradient) { this.v = v; this.dv = gradient; }
+
+    public MultivariateDual<V> Clone() { return new MultivariateDual<V>(this); }
+
+    public MultivariateDual<V> Zero => new MultivariateDual<V>(Value.Zero, Gradient.Zero);
+    public MultivariateDual<V> One => new MultivariateDual<V>(Value.One, Gradient.Zero);
+
+    public MultivariateDual<V> Scale(double s) { v.Scale(s); dv.Scale(s); return this; }
+
+    public MultivariateDual<V> Add(MultivariateDual<V> a) { v.Add(a.v); dv.Add(a.dv); return this; }
+    public MultivariateDual<V> Sub(MultivariateDual<V> a) { v.Sub(a.v); dv.Sub(a.dv); return this; }
+    public MultivariateDual<V> Assign(MultivariateDual<V> a) { v.Assign(a.v); dv.Assign(a.dv); return this; }
+    public MultivariateDual<V> Mul(MultivariateDual<V> a) {
+      // (a(x) * b(x))' = b(x)*a(x)' + b(x)'*a(x);
+      var t1 = a.dv.Clone().Scale(v);
+      var t2 = dv.Clone().Scale(a.v);
+      dv.Assign(t1).Add(t2);
+
+      v.Mul(a.v);
+      return this;
+    }
+    public MultivariateDual<V> Div(MultivariateDual<V> a) { v.Div(a.v); dv.Mul(a.dv.Inv()); return this; }
+    public MultivariateDual<V> AssignNeg(MultivariateDual<V> a) { v.AssignNeg(a.v); dv.AssignNeg(a.dv); return this; }
+    public MultivariateDual<V> AssignInv(MultivariateDual<V> a) { v.AssignInv(a.v); dv.AssignNeg(a.dv).Scale(v).Scale(v); return this; }   // (1/f(x))' = - f(x)' / f(x)^2
+
+    public MultivariateDual<V> AssignSin(MultivariateDual<V> a) { v.AssignSin(a.v); dv.Assign(a.dv).Scale(a.v.Clone().Cos()); return this; }
+    public MultivariateDual<V> AssignCos(MultivariateDual<V> a) { v.AssignCos(a.v); dv.AssignNeg(a.dv).Scale(a.v.Clone().Sin()); return this; }
+    public MultivariateDual<V> AssignTanh(MultivariateDual<V> a) { v.AssignTanh(a.v); dv.Assign(a.dv.Scale(v.Clone().IntPower(2).Neg().Add(Value.One))); return this; }     // tanh(f(x))' = f(x)'sech²(f(x)) = f(x)'(1 - tanh²(f(x)))
+
+    public MultivariateDual<V> AssignIntPower(MultivariateDual<V> a, int p) { v.AssignIntPower(a.v, p); dv.Assign(a.dv).Scale(p).Scale(a.v.Clone().IntPower(p - 1)); return this; }
+    public MultivariateDual<V> AssignIntRoot(MultivariateDual<V> a, int r) { v.AssignIntRoot(a.v, r); dv.Assign(a.dv).Scale(1.0 / r).Scale(a.v.IntRoot(r - 1)); return this; }
+
+    public MultivariateDual<V> AssignExp(MultivariateDual<V> a) { v.AssignExp(a.v); dv.Assign(a.dv).Scale(v); return this; } // exp(f(x)) = exp(f(x))*f(x)'     
+    public MultivariateDual<V> AssignLog(MultivariateDual<V> a) { v.AssignLog(a.v); dv.Assign(a.dv).Scale(a.v.Clone().Inv()); return this; }     // log(x)' = 1/f(x) * f(x)' 
+
+    public MultivariateDual<V> AssignAbs(MultivariateDual<V> a) { v.AssignAbs(a.v); dv.Assign(a.dv).Scale(a.v.Clone().Sgn()); return this; }      // abs(f(x))' = f(x)*f'(x) / |f(x)|  doesn't work for intervals      
+    public MultivariateDual<V> AssignSgn(MultivariateDual<V> a) { v.AssignSgn(a.v); dv = a.dv.Zero; return this; } // sign(f(x))' = 0;     
+
+    public MultivariateDual<V> AssignMin(MultivariateDual<V> other) {
+      XXX
+    }
+
+    public MultivariateDual<V> AssignMax(MultivariateDual<V> other) {
+      XXX
+    }
+  }
+}
Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/VectorAutoDiffEvaluator.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/VectorAutoDiffEvaluator.cs	(revision 17295)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/VectorAutoDiffEvaluator.cs	(revision 17295)
@@ -0,0 +1,145 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  public sealed class VectorAutoDiffEvaluator : Interpreter<MultivariateDual<AlgebraicDoubleVector>> {
+    private const int BATCHSIZE = 128;
+    [ThreadStatic]
+    private Dictionary<string, double[]> cachedData;
+
+    [ThreadStatic]
+    private IDataset dataset;
+
+    [ThreadStatic]
+    private int rowIndex;
+
+    [ThreadStatic]
+    private int[] rows;
+
+    [ThreadStatic]
+    private Dictionary<ISymbolicExpressionTreeNode, int> node2paramIdx;
+
+    private void InitCache(IDataset dataset) {
+      this.dataset = dataset;
+      cachedData = new Dictionary<string, double[]>();
+      foreach (var v in dataset.DoubleVariables) {
+        cachedData[v] = dataset.GetDoubleValues(v).ToArray();
+      }
+    }
+
+    /// <summary>
+    /// 
+    /// </summary>
+    /// <param name="tree"></param>
+    /// <param name="dataset"></param>
+    /// <param name="rows"></param>
+    /// <param name="parameterNodes"></param>
+    /// <param name="fi">Function output. Must be allocated by the caller.</param>
+    /// <param name="jac">Jacobian matrix. Must be allocated by the caller.</param>
+    public void Evaluate(ISymbolicExpressionTree tree, IDataset dataset, int[] rows, ISymbolicExpressionTreeNode[] parameterNodes, double[] fi, double[,] jac) {
+      if (cachedData == null || this.dataset != dataset) {
+        InitCache(dataset);
+      }
+
+      int nParams = parameterNodes.Length;
+      node2paramIdx = new Dictionary<ISymbolicExpressionTreeNode, int>();
+      for (int i = 0; i < parameterNodes.Length; i++) node2paramIdx.Add(parameterNodes[i], i);
+
+      var code = Compile(tree);
+
+      var remainingRows = rows.Length % BATCHSIZE;
+      var roundedTotal = rows.Length - remainingRows;
+
+      this.rows = rows;
+
+      for (rowIndex = 0; rowIndex < roundedTotal; rowIndex += BATCHSIZE) {
+        Evaluate(code);
+        code[0].value.Value.CopyTo(fi, rowIndex, BATCHSIZE);
+
+        // TRANSPOSE into JAC
+        var g = code[0].value.Gradient;
+        for (int j = 0; j < nParams; ++j) {
+          if (g.Elements.TryGetValue(j, out AlgebraicDoubleVector v)) {
+            v.CopyColumnTo(jac, j, rowIndex, BATCHSIZE);
+          } else {
+            for (int r = 0; r < BATCHSIZE; r++) jac[rowIndex + r, j] = 0.0;
+          }
+        }
+      }
+
+      if (remainingRows > 0) {
+        Evaluate(code);
+        code[0].value.Value.CopyTo(fi, roundedTotal, remainingRows);
+
+        var g = code[0].value.Gradient;
+        for (int j = 0; j < nParams; ++j)
+          if (g.Elements.TryGetValue(j, out AlgebraicDoubleVector v)) {
+            v.CopyColumnTo(jac, j, roundedTotal, remainingRows);
+          } else {
+            for (int r = 0; r < remainingRows; r++) jac[roundedTotal + r, j] = 0.0;
+          }
+      }
+    }
+
+    protected override void InitializeInternalInstruction(ref Instruction instruction, ISymbolicExpressionTreeNode node) {
+      var zero = new AlgebraicDoubleVector(BATCHSIZE);
+      instruction.value = new MultivariateDual<AlgebraicDoubleVector>(zero);
+    }
+
+    protected override void InitializeTerminalInstruction(ref Instruction instruction, ConstantTreeNode constant) {
+      var g_arr = new double[BATCHSIZE];
+      if (node2paramIdx.TryGetValue(constant, out var paramIdx)) {
+        for (int i = 0; i < BATCHSIZE; i++) g_arr[i] = 1.0;
+        var g = new AlgebraicDoubleVector(g_arr);
+        instruction.value = new MultivariateDual<AlgebraicDoubleVector>(new AlgebraicDoubleVector(BATCHSIZE), paramIdx, g); // only a single column for the gradient
+      } else {
+        instruction.value = new MultivariateDual<AlgebraicDoubleVector>(new AlgebraicDoubleVector(BATCHSIZE));
+      }
+
+      instruction.dblVal = constant.Value;
+      instruction.value.Value.AssignConstant(instruction.dblVal);
+    }
+
+    protected override void InitializeTerminalInstruction(ref Instruction instruction, VariableTreeNode variable) {
+      double[] data;
+      if (cachedData.ContainsKey(variable.VariableName)) {
+        data = cachedData[variable.VariableName];
+      } else {
+        data = dataset.GetReadOnlyDoubleValues(variable.VariableName).ToArray();
+        cachedData[variable.VariableName] = (double[])instruction.data;
+      }
+
+      var paramIdx = -1;
+      if (node2paramIdx.ContainsKey(variable)) {
+        paramIdx = node2paramIdx[variable];
+        var f = new AlgebraicDoubleVector(BATCHSIZE);
+        var g = new AlgebraicDoubleVector(BATCHSIZE);
+        instruction.value = new MultivariateDual<AlgebraicDoubleVector>(f, paramIdx, g);
+      } else {
+        var f = new AlgebraicDoubleVector(BATCHSIZE);
+        instruction.value = new MultivariateDual<AlgebraicDoubleVector>(f);
+      }
+
+      instruction.dblVal = variable.Weight;
+      instruction.data = new object[] { data, paramIdx };
+    }
+
+    protected override void LoadVariable(Instruction a) {
+      var paramIdx = (int)((object[])a.data)[1];
+      var data = (double[])((object[])a.data)[0];
+
+      for (int i = rowIndex; i < rows.Length && i - rowIndex < BATCHSIZE; i++) a.value.Value[i - rowIndex] = data[rows[i]];
+      a.value.Scale(a.dblVal);
+
+      if (paramIdx >= 0) {
+        // update gradient with variable values
+        var g = a.value.Gradient.Elements[paramIdx];
+        for (int i = rowIndex; i < rows.Length && i - rowIndex < BATCHSIZE; i++) {
+          g[i - rowIndex] = data[rows[i]];
+        }
+      }
+    }
+  }
+}
Index: /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/VectorEvaluator.cs
===================================================================
--- /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/VectorEvaluator.cs	(revision 17295)
+++ /branches/2994-AutoDiffForIntervals/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/VectorEvaluator.cs	(revision 17295)
@@ -0,0 +1,81 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  public sealed class VectorEvaluator : Interpreter<AlgebraicDoubleVector> {
+    private const int BATCHSIZE = 128;
+    [ThreadStatic]
+    private Dictionary<string, double[]> cachedData;
+
+    [ThreadStatic]
+    private IDataset dataset;
+
+    [ThreadStatic]
+    private int rowIndex;
+
+    [ThreadStatic]
+    private int[] rows;
+
+    private void InitCache(IDataset dataset) {
+      this.dataset = dataset;
+      cachedData = new Dictionary<string, double[]>();
+      foreach (var v in dataset.DoubleVariables) {
+        cachedData[v] = dataset.GetReadOnlyDoubleValues(v).ToArray();
+      }
+    }
+
+    public double[] Evaluate(ISymbolicExpressionTree tree, IDataset dataset, int[] rows) {
+      if (cachedData == null || this.dataset != dataset) {
+        InitCache(dataset);
+      }
+
+      this.rows = rows;
+      var code = Compile(tree);
+      var remainingRows = rows.Length % BATCHSIZE;
+      var roundedTotal = rows.Length - remainingRows;
+
+      var result = new double[rows.Length];
+
+      for (rowIndex = 0; rowIndex < roundedTotal; rowIndex += BATCHSIZE) {
+        Evaluate(code);
+        code[0].value.CopyTo(result, rowIndex, BATCHSIZE);
+      }
+
+      if (remainingRows > 0) {
+        Evaluate(code);
+        code[0].value.CopyTo(result, roundedTotal, remainingRows);
+      }
+
+      return result;
+    }
+
+    protected override void InitializeTerminalInstruction(ref Instruction instruction, ConstantTreeNode constant) {
+      instruction.dblVal = constant.Value;
+      instruction.value = new AlgebraicDoubleVector(BATCHSIZE);
+      instruction.value.AssignConstant(instruction.dblVal);
+    }
+
+    protected override void InitializeTerminalInstruction(ref Instruction instruction, VariableTreeNode variable) {
+      instruction.dblVal = variable.Weight;
+      instruction.value = new AlgebraicDoubleVector(BATCHSIZE);
+      if (cachedData.ContainsKey(variable.VariableName)) {
+        instruction.data = cachedData[variable.VariableName];
+      } else {
+        instruction.data = dataset.GetDoubleValues(variable.VariableName).ToArray();
+        cachedData[variable.VariableName] = (double[])instruction.data;
+      }
+    }
+
+    protected override void InitializeInternalInstruction(ref Instruction instruction, ISymbolicExpressionTreeNode node) {
+      instruction.value = new AlgebraicDoubleVector(BATCHSIZE);
+    }
+
+    protected override void LoadVariable(Instruction a) {
+      var data = (double[])a.data;
+      for (int i = rowIndex; i < rows.Length && i - rowIndex < BATCHSIZE; i++) a.value[i - rowIndex] = data[rows[i]];
+      a.value.Scale(a.dblVal);
+    }
+  }
+}
